//SGM-RCam            www.sgm.siedlce.pl

//procesor Arduino Pro Mini

//Pilot IR do zdalnego wyzwalania migawki aparatu fot., 3 tryby pracy
//mode 1 - jednorazowe wyzwalanie przyciskiem lub
//         automatyczne wyzwalanie co zaprogaramowana liczbe sekund
//         (wcisniecie i przytrzymanie przycisku dluzej niz 1 sek.)
//mode 2 - wyzwalanie poprzez odbiornik RC
//mode 3 - programowanie liczby sekund do automatycznego cyklicznego
//         wyzwalania 

//Program korzysta z bibiloteki multiCameraIrControl.h, autor Sebastian Setz

//Library multiCameraIrControl.h by Sebastian Setz
/*************************************************
 * Author.....:  Sebastian Setz
 * Version....:  1.2
 * Date.......:  2011-01-25
 * Project....:  http://sebastian.setz.name/arduino/my-libraries/multi-Camera-IR-Control
 * Contact....:  http://Sebastian.Setz.name
 * License....:  This work is licensed under the Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License.
 *               To view a copy of this license, visit http://creativecommons.org/licenses/by-nc-sa/3.0/ or send a letter to
 *               Creative Commons, 171 Second Street, Suite 300, San Francisco, California, 94105, USA.
 * Keywords...:  arduino, library, camera, ir, control, canon, nikon, olympus, minolta, sony, pentax, interval, timelapse
 * History....:  2010-12-08 V1.0 - release
 *               2011-01-04 V1.1
 *               2011-01-25 V1.2 - changing pin number, because the wiring at the homepage was different
 *
 *************************************************/

#include <multiCameraIrControl.h>

//Obsluguje marki: Nikon, Canon, CanonWLDC100, Pentax, Olympus, Minolta, Sony
//dla innego aparatu niz Olympus odremowac odpowiedni wiersz ponizej 

Olympus camera(11);           // dioda iR na Pin11
//Canon camera(11);
//Minolta camera(11);
//Pentax camera(11);
//Sony camera(11);

#include <EEPROM.h>           //biblioteka do obsługi zapisu/odczytu EEProm

const int butIrq = 1;         // Irq 1 na Pin3
const int butPin = 3;         // przycisk na Pin3
const int LED = 13;           // LED na Pin 13
byte PinRx = 12;              // sygnal PPM (1 kanal) podlaczony do Pin12
byte ppmON = 0;               // zmienne do obslugi PPM
int PPM1 = 1100;              // zmienna na dlugosc impulsu PPM1
int Rx1 = 0;
unsigned long Tout = 20000;   // timeout dla PMM


int L1 = 0;                   //licznk pierwszej sekwencji LED
const int L1max = 6;          //maks ilosc sekwencji L1 (n-1)  

int i;
int PgmMode = 0;
int M1 = 0;
int M2 = 0;
unsigned long but_time = 0;  
unsigned long last_but_time = 0;
int TstZW1;                    // stan zworki analogowej 1
int TstZW2;                    // stan zworki analogowej 2
byte C1;                       // wspólcz.1
byte C2;                       // współcz.2
int autoS;                     // czas autowyzwalania
const int C3=1;                // współcz.3 (stały współcz.)

byte SingleS=0;                //pojedyncze wyzwolenie
byte TstBut=0;


void setup()
{                
  pinMode(LED, OUTPUT);
  digitalWrite(LED, LOW);
  pinMode(butPin, INPUT);
  pinMode(PinRx,INPUT);  // ustaw PinRx jako wejscie  
  i = 0;
  L1 = 1;

TstZW1 = analogRead(1);
TstZW2 = analogRead(2);


if (TstZW1 <500){
  TstZW1=0;
} else {
  TstZW1=1;
}

if (TstZW2 <500){
  TstZW2=0;
} else {
  TstZW2=1;
}

if ((TstZW1==1) & (TstZW2==1)) { //programowanie autowyzwalania
 PgmMode = 3;
}
if ((TstZW1==0) & (TstZW2==1)) { //wyzwalanie przyciskiem
 PgmMode = 2;
 attachInterrupt(butIrq, butPress, RISING);
}
if ((TstZW1==1) & (TstZW2==0)) { //wyzwalanie RC
 PgmMode = 1;
}

C1 = EEPROM.read(1);
C2 = EEPROM.read(2);
if (C1==0) {  // odczyt mnoznika 1
 C1=1; 
}
if (C2==0) {  // odczyt mnoznika 2
 C2=1; 
}
autoS = C1*C2*C3; // oblicz. autowyzwalanie
  
}


void loop()                     
{

 switch (PgmMode) {  
 case 1:          // wyzwalanie RC
  Rx1=digitalRead(PinRx); 
  if (Rx1==0)
  {
   PPM1=pulseIn(PinRx,HIGH,Tout); 

   if (PPM1 == 0) {
     PPM1 = 1100;  
    } 
   if (PPM1<1200)  { //& (ppmON==1)
     ppmON=0; 
    }  
   if ((PPM1>1200) & (ppmON==0))  {   
    camera.shutterNow();            //migawka
    digitalWrite(LED, HIGH);
    delay(200);
    digitalWrite(LED, LOW);
    ppmON=1;
    delay(1000);
   }
  }
 break; // case 1       

 case 2:         // wyzwalanie przyciskiem (pojedyncze i auto)
  if (SingleS==1) {
   camera.shutterNow();      //migawka
   digitalWrite(LED, HIGH);
   delay(1000);
   digitalWrite(LED, LOW);
   SingleS=0;
   TstBut = digitalRead(butPin);  
   if (TstBut==1) {           // jesli przycisk wcisniety > 1sek
    detachInterrupt(butIrq);
    PgmMode = 7;              //przejdz do wyzwalania auto
    delay(1000);
   }  
  }
  
 break; // case 2
 
 // tryb programowanie czasu wyzwalania okresowego
 // (case 3, case 4, case 5)
 
 case 3: // pierwsza petla - sygnalizacja - 2 srednie blyski
  delay(1000);
  digitalWrite(LED, HIGH);
  delay(500);
  digitalWrite(LED, LOW);
  delay(500);
  digitalWrite(LED, HIGH);
  delay(500);
  digitalWrite(LED, LOW);
  delay(1000);
  PgmMode = 4;

 break; // case 3

 case 4: // druga  petla  - pierwszy mnoznik  

    digitalWrite(LED, HIGH);
    attachInterrupt(butIrq, butPress, RISING);
    delay(10000);
    detachInterrupt(butIrq);
    digitalWrite(LED, LOW);
    delay(400);
    digitalWrite(LED, HIGH);
    delay(50);
    digitalWrite(LED, LOW);
    delay(100);
    digitalWrite(LED, HIGH);
    delay(50);
    digitalWrite(LED, LOW);
    delay(400);
    PgmMode = 5;

 break;  // case 4
 
   case 5: // trzecia petla blyskow 1 sek - drugi mnoznik 

    delay(400);   
    digitalWrite(LED, HIGH);
    attachInterrupt(butIrq, butPress, RISING);
    delay(10000);
    detachInterrupt(butIrq);
    digitalWrite(LED, LOW);
    PgmMode = 6;
  
  break; //case 5
  
  case 6: // zapis do EEprom o ile byla zmiana
          // i powrot do petli
    if (M1>0){
     EEPROM.write(1, M1); //zapisz pierwszy mnoznik C1
    }
    if (M2>0){
    EEPROM.write(2, M2);  //zapisz drugi mnoznik C2
    }
    M1 = 0;
    M2 = 0;
    PgmMode = 3;
    L1=1;
    
  break; //case 6

  case 7: // okresowe wyzwalanie automatyczne
   for (int n=0; n < (autoS-1); n++) {
    digitalWrite(LED, HIGH);
    delay(100);
    digitalWrite(LED, LOW);
    delay(900); 
   }
   digitalWrite(LED, HIGH);
   delay(100);
   digitalWrite(LED, LOW);
   delay(100);
   digitalWrite(LED, HIGH);
   delay(100);
   digitalWrite(LED, LOW);
   camera.shutterNow();          //autowyzwolenie
   delay(700);
  break; //case 6
  
  default: // jesli zadna z powyzszych
  break;   // default 
 } // switch 
   
 
}

//obsluga przerwania
void butPress()             // obsluga przycisku w trybie wyzwalania
{                           // i programowania autowyzwalania
  but_time = millis();
  if (but_time - last_but_time > 250) //jesli poprzednie wcisniecie
  {                                   //wczesniej niz 250msec
   last_but_time = but_time;
   if (PgmMode == 2) {                //jesli w trybie 2
    SingleS=1;
   }
   if (PgmMode == 4) {                //jesli w trybie 4 
    M1++; 
   }
   if (PgmMode == 5) {                //jesli w trybie 5
    M2++;  
   } 
  } 
}


